unit ICQU;

interface

uses
  WinSock, Windows, SysUtils, Forms, ComCtrls, ExtCtrls, Buttons, Controls,
  StdCtrls, ScktComp, Classes, Dialogs;

type
  TFICQ = class(TForm)
    ClientSocket1: TClientSocket;
    ServerSocket1: TServerSocket;
    RichEdit2: TRichEdit;
    RichEdit1: TRichEdit;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    CPEnviar: TBitBtn;
    Bevel2: TBevel;
    Label1: TLabel;
    Bevel1: TBevel;
    CPConectar: TBitBtn;
    OpenDialog1: TOpenDialog;
    ContagemP: TPanel;
    ContagemT1: TStaticText;
    procedure ServerSocket1ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure CPEnviarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CPConectarClick(Sender: TObject);
  private
    function Info_Arquivo(Arquivo: String): String;
end;

var
  FICQ: TFICQ;
  Texto: String;
  Contagem: Integer;
  Download: Boolean = False;

implementation

uses SolicitacaoU;

{$R *.dfm}

procedure TFICQ.FormCreate(Sender: TObject);
var
   Name, EndIP: String;
   WSAData: TWSAData;
   HostEnt: PHostEnt;
begin
  RichEdit1.Clear;
  RichEdit2.Clear;
  WSAStartup(2,WSAData);
  SetLength(Name,255);
  Gethostname(PChar(Name),255);
  SetLength(Name,StrLen(PChar(Name)));
  HostEnt:=GetHostbyName(PChar(Name));
  with HostEnt^ do EndIP:=Format('%d.%d.%d.%d',[Byte(h_addr^[0]),Byte(h_addr^[1]),Byte(h_addr^[2]),Byte(h_addr^[3])]);
  WSACleanup;
  StatusBar1.Panels[1].Text:='Meu IP: '+EndIP;
  StatusBar1.Panels[0].Text:=FormatDateTime('DD/MM/YYYY HH:MM:SS',Now);
  ServerSocket1.Port:=21;
  ServerSocket1.Active:=True;
end;

procedure TFICQ.CPConectarClick(Sender: TObject);
begin
  RichEdit1.SetFocus;
  Solicitacao.Label1.Caption:='Informe o IP destino!';
  Solicitacao.Edit1.Clear;
  Solicitacao.ShowModal;
  if Trim(Solicitacao.Edit1.Text)<>'' then if not ClientSocket1.Active then
    begin
      //Envia o IP do servidor
      ClientSocket1.Address:=Solicitacao.Edit1.Text;
      ClientSocket1.Active:=True;
      while not ClientSocket1.Active do Application.ProcessMessages;
      ClientSocket1.Socket.SendText(Copy(StatusBar1.Panels[1].Text,9,Length(StatusBar1.Panels[1].Text)-8));
    end;
end;

procedure TFICQ.ServerSocket1ClientRead(Sender: TObject; Socket: TCustomWinSocket);
var
  Buffer: array [0..1023] of Char;
  Stream: TMemoryStream;
  BytesRecebidos: Integer;
begin
  if Download then
    begin
      ContagemP.Visible:=True;
      ContagemP.Update;
      Stream:=TMemoryStream.Create;
      Stream.Position:=0;
      repeat
        BytesRecebidos:=Socket.ReceiveBuf(Buffer,Sizeof(Buffer));
        Stream.Write(Buffer,BytesRecebidos);
        Contagem:=Contagem-BytesRecebidos;
        if Contagem<10 then ContagemT1.Caption:='Finalizando...' else ContagemT1.Caption:=IntToStr(Contagem);
        ContagemP.Update;
        Sleep(200);
      until BytesRecebidos<=0;
      Stream.SaveToFile('C:\'+Texto);
      Stream.Free;
      Download:=False;
      ContagemP.Visible:=False;
    end
  else
    begin
      if ClientSocket1.Active=False then
        begin
          //Recebe IP do servidor
          CPConectar.Enabled:=False;
          ClientSocket1.Address:=Socket.ReceiveText;
          ClientSocket1.Active:=True;
          while not ClientSocket1.Active do Application.ProcessMessages;
          //Envia nick do cliente
          ClientSocket1.Socket.SendText(StatusBar1.Panels[2].Text);
        end
      else
        begin
          if RichEdit2.Lines.Count=0 then
            begin
              CPConectar.Enabled:=False;
              //Recebe nick do cliente
              StatusBar1.Panels[3].Text:=Socket.ReceiveText;
              //Envia nick para o servidor
              ClientSocket1.Socket.SendText(StatusBar1.Panels[2].Text);
              RichEdit2.Lines.Add('Conexo estabelecida com '+StatusBar1.Panels[3].Text);
            end
          else
            begin
              Texto:=Socket.ReceiveText;
              if (StatusBar1.Panels[3].Text<>Texto) and (not Download)then
                begin
                  RichEdit2.Lines.Add(StatusBar1.Panels[3].Text);
                  if Copy(Texto,11,29)='Efetuar download do arquivo: ' then
                    begin
                      Download:=True;
                      Contagem:=StrToInt(Copy(Texto,1,10));
                      Texto:=ExtractFileName(Copy(Texto,40,Length(Texto)-39));
                      RichEdit2.Lines.Add('Recebendo arquivo: '+Texto);
                    end
                  else RichEdit2.Lines.Add(Texto);
                end;
            end;
        end;
    end;
end;

function TFICQ.Info_Arquivo(Arquivo: String): String;
var
//  Temp1 :Integer;
  Temp2 :TFileStream;
begin
//  Temp1:=FileGetAttr(Arquivo);
  Temp2:=TFileStream.Create(Arquivo, fmOpenRead or fmShareDenyWrite);
//  if(Temp1 and faReadOnly<>0) then Result:=Result+'1' else Result:=Result+'0';
//  if(Temp1 and faHidden<>0)   then Result:=Result+'1' else Result:=Result+'0';
//  if(Temp1 and faArchive<>0)  then Result:=Result+'1' else Result:=Result+'0';
//  if(Temp1 and faSysFile<>0)  then Result:=Result+'1' else Result:=Result+'0';
  Result:=FormatFloat('0000000000',Temp2.Size)+'Efetuar download do arquivo: '+Arquivo;
  Temp2.Free;
end;

procedure TFICQ.CPEnviarClick(Sender: TObject);
var
  Temp: TDateTime;
begin
  if UpperCase(RichEdit1.Text)='#ARQUIVO' then
    begin
      if OpenDialog1.Execute then
        begin
          Temp:=Now;
          ClientSocket1.Socket.SendText(Info_Arquivo(OpenDialog1.FileName));
          while Temp+0.0001>=Now do Application.ProcessMessages; //Para uns 5 segundos.
          ClientSocket1.Socket.SendStream(TFileStream.Create(OpenDialog1.FileName,fmOpenRead or fmShareDenyWrite));
        end;
    end
  else
    begin
      ClientSocket1.Socket.SendText(RichEdit1.Text);
      RichEdit2.Lines.Add(StatusBar1.Panels[2].Text);
      RichEdit2.Lines.Add(RichEdit1.Text);
      RichEdit1.SetFocus;
      RichEdit1.Clear;
    end;
end;

procedure TFICQ.Timer1Timer(Sender: TObject);
begin
  StatusBar1.Panels[0].Text:=FormatDateTime('DD/MM/YYYY HH:MM:SS',Now);
end;

procedure TFICQ.FormActivate(Sender: TObject);
begin
  Solicitacao.ShowModal;
  if Trim(Solicitacao.Edit1.Text)='' then Close;
  StatusBar1.Panels[2].Text:=Solicitacao.Edit1.Text;
end;

end.




